@echo off
set appname="KeyCode"
set debug=0
set console=0
set run=0
set pack=0

set BIN=\GeneSys\bin
set LIB=\GeneSys\lib
set INCLUDE=\GeneSys\include

if not exist %bin%\ml.exe goto patherror
if not exist %bin%\polink.exe goto patherror

if %console%==1 goto console
if %debug%==1 goto windebugver

:winreleasever
    %bin%\ml /c /coff /Cp %appname%.asm >trash.can
    if not exist %appname%.obj goto errorout
    del trash.can

    if not exist %appname%.rc goto noresources
    \GeneSys\bin\rc.exe /v %appname%.rc
    if not exist %appname%.res goto reserror
    ren %appname%.RES %appname%.res

    %bin%\polink /SUBSYSTEM:WINDOWS /RELEASE /VERSION:4.0 %appname%.obj %appname%.res
    goto finish

:noresources
    %bin%\polink /SUBSYSTEM:WINDOWS /RELEASE /VERSION:4.0 %appname%.obj
    goto finish

:windebugver
    %bin%\ml /c /coff /Cp /Fm /Zi /Zd %appname%.asm >trash.can
    if not exist %appname%.obj goto errorout
    del trash.can

    if not exist %appname%.rc goto noresfile
    \GeneSys\bin\rc.exe /v %appname%.rc
    if not exist %appname%.res goto reserror
    ren %file%.RES %appname%.res

    %bin%\polink /SUBSYSTEM:WINDOWS /DEBUG /DEBUGTYPE:CV /VERSION:4.0 /INCREMENTAL:NO %appname%.obj %appname%.res
    goto finish

:noresfile
    %bin%\polink /SUBSYSTEM:WINDOWS /DEBUG /DEBUGTYPE:CV /VERSION:4.0 /INCREMENTAL:NO %appname%.obj
    goto finish

:console
    if %debug%==1 goto consoledebugver

:consolereleasever
    %bin%\ml /c /coff /Cp %appname%.asm >trash.can
    if not exist %appname%.obj goto errorout
    del trash.can
    echo.
    %bin%\polink /SUBSYSTEM:CONSOLE /RELEASE /VERSION:4.0 %appname%.obj
    goto finish

:consoledebugver
    %bin%\ml /c /coff /Cp /Fm /Zi /Zd %appname%.asm >trash.can
    if not exist %appname%.obj goto errorout
    del trash.can
    echo.
    %bin%\polink /SUBSYSTEM:CONSOLE /DEBUG /VERSION:4.0 %appname%.obj

:finish
    if %pack%==0 goto done
    if not exist %bin%\upx.exe goto done
    %bin%\upx.exe %appname%.exe

:done
    if exist %appname%.obj del %appname%.obj
    if exist %appname%.res del %appname%.res
    echo.
    echo The build has completed successfully.
    pause
    cls
    if %run%==0 goto end
    %appname%.exe
    goto end

:reserror
    echo.
    echo Trying to create the resource file generates the above mentioned errors...
    echo.
    pause    
    goto end

:errorout
    echo Trying to create the object file generates the following report...
    echo.
    type trash.can
    echo.
    pause    
    goto end

:patherror
    echo.
    echo ML.EXE was not found in the path - compilation terminated.

:end

:Universal makeit.bat v1.01 by Mark Jones 2005, features added by the Rifleman.